#include <iostream>
#include "Vector.hh"
#include "Body.hh"
#include "Cuboid.hh"
#include "Cylinder.hh"

int main() 
{
  const int N = 10000;//Anzahl Integrationspunkte
  const double M = 1;//Masse des Zylinders


  Vector a;//Punkt auf der Rotationsachse
  Vector u;//Richtung der Rotationsachse
  
  std::cout << "point on axis:";
  std::cin >> a;
  std::cout << "direction of axis:";
  std::cin >> u;

  std::cout << "Which body (q=Cuboid,z=Cylinder)?";
  char c;
  std::cin >> c;
  Body* body = 0;
  if(c == 'q') {
    body = new Cuboid(1,2,3);
  } else if(c == 'z') {
    body = new Cylinder(1,2);
  } else {
    std::cout << "unknow body:" << c << std::endl;
    return 0;
  }

  double J = 0;//Massentraegheitsmoment
  double m = M/N;//Masse eines Massenpunktes
  for(int i = 0 ; i < N ; ++i) {
    Vector x = body->point();
    //Abstand Punkt x und Gerade a + t*u
    Vector n = cross(x-a,u);//Normalenvektor
    double r = n.length()/u.length();
    //std::cout << x << " :" << r << std::endl;
    // addiere Beitrag des Massenpunktes zum Traegheitsmoment
    J += m * r*r;
  }
  std::cout << "moment of inertia for a " << body->name() 
	    << " with a = " << a << " and u = " << u 
	    << " :" << J << std::endl;
  delete body;
  return 0;
}
